/*
 * slave1 - for the TREE communication structure
 *
 * just receives from the parent the number of UNITS to compute, then 
 * compute them, reporting progress every SIM_REPORT_PROGRESS units and 
 * after finish sending the MSG_READY message
 * terminates on MSG_QUIT
 */
#include <pvm3.h>
#include "common.h"

volatile int terminate=0;

int main(void){
  int myTID;
  int bufid;
  
  int bytes;
  int type;
  int source;
  
  int todo=0;
  int progress;
  
  // find out mu tid
  myTID = pvm_mytid();

  /* send to the parent that we are ready */
  pvm_initsend(PvmDataDefault);
  pvm_send(pvm_parent(),MSG_READY);

  while(!terminate){
    bufid=pvm_recv(pvm_parent(),-1);
    if(bufid>=0){
      pvm_bufinfo(bufid,&bytes,&type,&source);
      
      switch(type){
	case MSG_QUIT: terminate=1;
		       break;
	case MSG_JOB:  pvm_upkint(&todo,1,1);
		       progress=0;
		       break;
      }
    }
    
    if(terminate)break;
    
    while(todo>0){
      sim_compute_unit();
      progress++;
      if(progress>=SIM_REPORT_PROGRESS){
        pvm_initsend(PvmDataDefault);
        pvm_pkint(&progress,1,1);
        pvm_send(pvm_parent(),MSG_REPORT);
	progress=0;
      }
      todo--;
    }
    if(progress>0){
      pvm_initsend(PvmDataDefault);
      pvm_pkint(&progress,1,1);
      pvm_send(pvm_parent(),MSG_REPORT);
    }
    pvm_initsend(PvmDataDefault);
    pvm_send(pvm_parent(),MSG_READY);
  }

  pvm_exit();

  return 0;
}
